
/*---------------------------------------------------------------------------
      Chapter 8: Intelligent techniques of Logic Programming (Paragraph 8.3)
      This code is part of the book
      LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
      Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
      Hellenic Academic On-line Publications, 2015
    ----------------------------------------------------------------------------*/
    
/** Symbolic programming   **/

/* finding sum as a symbolic formula  */

symbolic_sum([],0).

symbolic_sum([H|T],H+ST):-
  symbolic_sum(T,ST).

/* finding the arithmetic value result of sum  */

arithmetic_sum(L,SA):-
  symbolic_sum(L,S),
  SA is S.

/* finding the derivative of a function as a symbolic formula  */

derivative(X, X, 1). 

derivative(C, X, 0) :- atomic(C), C \==X.

derivative(sin(X), X, cos(X)).

derivative(cos(X), X, -sin(X)).

derivative(U+V, X, A+B) :- 
	derivative(U, X, A), 
	derivative(V, X, B).

derivative(U*V, X, A*V+B*U) :- 
	derivative(U, X, A), 
	derivative(V, X, B).